/******************************************************************************
 * Copyright (C), 
 * Funtion: 
 * Author : jlicon@qq.com 
 * CPU    : flash:60kbyte   ram:20kbyte
 * Date   : 2015.11.05
 * pingtai: MDK V5.11
*******************************************************************************/
/* include "header file" -----------------------------------------------------*/
#include "config.h"
#include "FreeRTOS.h"
#include "task.h"

/* Declaration Variable structure --------------------------------------------*/

#ifdef __GNUC__
/* With GCC/RAISONANCE, small printf (option LD Linker->Libraries->Small printf
     set to 'Yes') calls __io_putchar() */
#define PUTCHAR_PROTOTYPE int __io_putchar(int ch)
#else
#define PUTCHAR_PROTOTYPE int fputc(int ch, FILE *f)
#endif /* __GNUC__ */


/* Declaration Variable bit --------------------------------------------------*/

/* Declaration function prototype --------------------------------------------*/
void BSP_USART_Init(void);
void RCC_Configuration(void);
void testTask(void *agr);







/*******************************************************
 * Title  : main
 * Explain: 
*******************************************************/
int main(void)
{
    RCC_Configuration();
    BSP_USART_Init();
    
    xTaskCreate( testTask,                      // ָ
                 "testTask",                    // 
                 configMINIMAL_STACK_SIZE,        // ջ()
                 NULL,                          // Ϊ
                 tskIDLE_PRIORITY+1,             // ȼ
                 NULL );                        // Ϊ
    /* (ϵͳʼ) */
    vTaskStartScheduler();

    while(1)
    {
//        for(u32 i = 0xffffff;i > 0;i--);
//        printf("wertyuiopfghjk");
    }
}



void testTask(void *agr)
{
    while(1)
    {
        vTaskDelay(500);   // ˯1000ms
        printf("sdfghjkldfghjklRTYGHJ");
    } 
}










void RCC_Configuration(void)
{
    RCC_DeInit();   // ΪĬֵ

    RCC_HSICmd(ENABLE);// HSI

    while(RCC_GetFlagStatus(RCC_FLAG_HSIRDY) == RESET)// ȴȶ
    {

    } 

    if(1)
    { 
        RCC_HCLKConfig(RCC_SYSCLK_Div1); //AHBʱΪϵͳʱSYSCLK

        RCC_PCLK2Config(RCC_HCLK_Div1);  //APB1ʱΪHCLK/2HCLKΪAHBʱ

        RCC_PCLK1Config(RCC_HCLK_Div2);  //APB2ʱΪHCLK

        // PLL ʱԴƵϵ

        RCC_PLLConfig(RCC_PLLSource_HSI_Div2, RCC_PLLMul_15);

        //ʹܻʧ PLL,ȡENABLEDISABLE

        RCC_PLLCmd(ENABLE);//PLLϵͳʱ,ôܱʧ

        //ȴָ RCC ־λóɹ ȴPLLʼɹ

        while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET)
        {

        }
        //ϵͳʱӣSYSCLK PLLΪϵͳʱԴ  
        RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);
        //ȴPLLɹϵͳʱӵʱԴ

        // 0x00HSI Ϊϵͳʱ

        // 0x04HSEΪϵͳʱ

        // 0x08PLLΪϵͳʱ

        while(RCC_GetSYSCLKSource() != 0x08)
        {

        }

    }
}


void BSP_USART_Init(void)
{
    GPIO_InitTypeDef GPIO_InitStructure;
    USART_InitTypeDef USART_InitStructure;


    /* 1GPIOUSARTʱ */
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_AFIO, ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);

    /* 2USART TxGPIOΪ츴ģʽ */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    /* 3USART RxGPIOΪģʽ
    CPUλGPIOȱʡǸģʽ費Ǳ
    ǣһǽϱĶҷֹط޸ߵò
    */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    /* 4 ôӲ */
    USART_InitStructure.USART_BaudRate = 115200;	/*  */
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No ;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
    USART_Init(USART1, &USART_InitStructure);

    //	USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);	/* ʹܽж */
    /*
    USART_ITConfig(USART1, USART_IT_TXE, ENABLE);
    ע: Ҫڴ˴򿪷ж
    жʹSendUart()
    */
    USART_Cmd(USART1, ENABLE);		/* ʹܴ */

    /* CPUСȱݣúãֱSend1ֽڷͲȥ
    1ֽ޷ȷͳȥ */
    USART_ClearFlag(USART1, USART_FLAG_TC);     /* 巢ɱ־Transmission Complete flag */
}


PUTCHAR_PROTOTYPE
{
    /* Place your implementation of fputc here */
    /* e.g. write a character to the USART */
    USART_SendData(USART1, (uint8_t) ch);
    /* Loop until the end of transmission */
    while (USART_GetFlagStatus(USART1, USART_FLAG_TC) == RESET);
    return ch;
} 


/******************* (C) COPYRIGHT 2014 ΰƼ޹˾ *****END OF FILE****/




